// RegToolDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RegTool.h"
#include "RegToolDlg.h"
#include ".\regtooldlg.h"
#include "afxwin.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
public:
	CMyHyperLink myLink;
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	myLink.SetLinkUrl("http://activex.moonvalley.com");
	myLink.ActiveToolTip(1);
	myLink.SetTootTipText("Visit the Moon Valley ActiveX page.");
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_LINK, myLink);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)

END_MESSAGE_MAP()


// CRegToolDlg dialog



CRegToolDlg::CRegToolDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRegToolDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRegToolDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRegToolDlg)
	// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_EDIT1, edtExists);
	DDX_Control(pDX, IDC_EDIT2, resExists);
	DDX_Control(pDX, IDC_EDIT3, edtPermissions);
	DDX_Control(pDX, IDC_EDIT4, resPermissions);
	DDX_Control(pDX, IDC_EDIT5, edtCollateSubkey);
	DDX_Control(pDX, IDC_EDIT6, edtCollateMask);
	DDX_Control(pDX, IDC_EDIT7, resCollate);
	DDX_Control(pDX, IDC_CHECK1, chkCollate);
	DDX_Control(pDX, IDC_EDIT9, edtNumSubkey);
	DDX_Control(pDX, IDC_EDIT10, edtNumVal);
	DDX_Control(pDX, IDC_EDIT13, resNum);
	DDX_Control(pDX, IDC_EDIT11, edtStrSubkey);
	DDX_Control(pDX, IDC_EDIT12, edtStrVal);
	DDX_Control(pDX, IDC_EDIT14, resStr);
	DDX_Control(pDX, IDC_REGTOOL, regtoolctrl);
	DDX_Control(pDX, IDC_EDIT8, resValNum);
	DDX_Control(pDX, IDC_EDIT15, resValStr);
	DDX_Control(pDX, IDC_MVSBUTTON, m_MVSButton);
}

BEGIN_MESSAGE_MAP(CRegToolDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON2, OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON5, OnBnClickedButton5)
	ON_BN_CLICKED(IDC_BUTTON6, OnBnClickedButton6)
	ON_BN_CLICKED(IDC_BUTTON7, OnBnClickedButton7)
	ON_BN_CLICKED(IDC_BUTTON8, OnBnClickedButton8)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON10, OnBnClickedButton10)
	ON_BN_CLICKED(IDC_BUTTON9, OnBnClickedButton9)
	ON_BN_CLICKED(IDC_MVSBUTTON, OnBnClickedMvsbutton)
END_MESSAGE_MAP()


// CRegToolDlg message handlers

BOOL CRegToolDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	m_MVSButton.LoadBitmap(IDB_BITMAP1);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRegToolDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRegToolDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRegToolDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}
void CRegToolDlg::OnBnClickedButton2()
{
	CString tmpStr;
	edtExists.GetWindowText(tmpStr);
	
	if (edtExists.LineLength() < 3)
		AfxMessageBox("Please enter a key");
	else if (regtoolctrl.KeyExists(tmpStr))
		resExists.SetWindowText("Yes");
	else
		resExists.SetWindowText("No");
}
void CRegToolDlg::OnBnClickedButton3()
{
	CString tmpStr;
	edtPermissions.GetWindowText(tmpStr);

	if (edtPermissions.LineLength() < 1)
		AfxMessageBox("Please enter a profile name");
	else if (regtoolctrl.ProfileIsUnlocked(tmpStr))
		resPermissions.SetWindowText("No");
	else
		resPermissions.SetWindowText("Yes");
}

void CRegToolDlg::OnBnClickedButton5()
{
	CString tmpStrSubkey;
	CString tmpStrMask;
	
	if (edtCollateSubkey.LineLength() < 1)
		AfxMessageBox("Please enter a subkey and mask");
	else
	{
		edtCollateSubkey.GetWindowText(tmpStrSubkey);
		edtCollateMask.GetWindowText(tmpStrMask);
		resCollate.SetWindowText(regtoolctrl.CollateSubKeyValues(tmpStrSubkey, tmpStrMask, chkCollate.GetCheck()));
	}
}

void CRegToolDlg::OnBnClickedButton6()
{
}

void CRegToolDlg::OnBnClickedButton7()
{
	CString tmpSubkey;
	CString tmpVal;

	if (edtNumSubkey.LineLength() < 1 || edtNumVal.LineLength() < 1)
		AfxMessageBox("Please enter a subkey and value");
	else
	{
		edtNumSubkey.GetWindowText(tmpSubkey);
		edtNumVal.GetWindowText(tmpVal);
		char szbuffer[20];
		itoa(regtoolctrl.GetNumericValue(tmpSubkey, tmpVal), szbuffer, 10);
		resValNum.SetWindowText(szbuffer);
	}
}

void CRegToolDlg::OnBnClickedButton8()
{
	CString tmpStrSubkey;
	CString tmpStrVal;

	if (edtStrSubkey.LineLength() < 1 || edtStrVal.LineLength() < 1)
		AfxMessageBox("Please enter a subkey and value");
	else
	{
		edtStrSubkey.GetWindowText(tmpStrSubkey);
		edtStrVal.GetWindowText(tmpStrVal);
		
		resValStr.SetWindowText(regtoolctrl.GetStringValue(tmpStrSubkey, tmpStrVal, 0));
	}
}

void CRegToolDlg::OnBnClickedButton10()
{
	CString tmpStrSubkey;
	CString tmpStrVal;
	CString tmpResStr;

	if (edtStrSubkey.LineLength() < 1 || edtStrVal.LineLength() < 1)
		AfxMessageBox("Please enter a subkey and value");
	else
	{
		edtStrSubkey.GetWindowText(tmpStrSubkey);
		edtStrVal.GetWindowText(tmpStrVal);
		resStr.GetWindowText(tmpResStr);

		regtoolctrl.SetStringValue(tmpStrSubkey, tmpStrVal, tmpResStr, 0);
	}
}

void CRegToolDlg::OnBnClickedButton9()
{
	CString tmpSubkey;
	CString tmpVal;
	CString tmpStr;
	int tmpInt;

	if (edtNumSubkey.LineLength() < 1 || edtNumVal.LineLength() < 1)
		AfxMessageBox("Please enter a subkey, a value, and a new value to set");
	else
	{
		edtNumSubkey.GetWindowText(tmpSubkey);
		edtNumVal.GetWindowText(tmpVal);

		resNum.GetWindowText(tmpStr);
		tmpInt = atoi(tmpStr);

		regtoolctrl.SetNumericValue(tmpSubkey, tmpVal, tmpInt);
	}
}

void CRegToolDlg::OnBnClickedMvsbutton()
{
	ShellExecute(NULL, "open", "http://activex.moonvalley.com", "", NULL, SW_SHOWNORMAL);
}
